Attribute VB_Name = "MFileProps"
' *************************************************************************
'  Copyright 1998-2002 Karl E. Peterson
'  All Rights Reserved, http://www.mvps.org/vb
' *************************************************************************
'  You are free to use this code within your own applications, but you
'  are expressly forbidden from selling or otherwise distributing this
'  source code, non-compiled, without prior written consent.
' *************************************************************************
Option Explicit

Private Declare Function ShellExecuteEx Lib "shell32.dll" Alias "ShellExecuteExA" (lpExecInfo As SHELLEXECUTEINFO) As Long

' ShellExecuteEx error codes
Private Const SE_ERR_FNF = 2                     '  file not found
Private Const SE_ERR_PNF = 3                     '  path not found
Private Const SE_ERR_ACCESSDENIED = 5            '  access denied
Private Const SE_ERR_OOM = 8                     '  out of memory
Private Const SE_ERR_DLLNOTFOUND = 32

' ShellExecuteEx flags
Private Const SEE_MASK_CLASSNAME = &H1
Private Const SEE_MASK_CLASSKEY = &H3
Private Const SEE_MASK_IDLIST = &H4
Private Const SEE_MASK_INVOKEIDLIST = &HC
Private Const SEE_MASK_ICON = &H10
Private Const SEE_MASK_HOTKEY = &H20
Private Const SEE_MASK_NOCLOSEPROCESS = &H40
Private Const SEE_MASK_CONNECTNETDRV = &H80
Private Const SEE_MASK_FLAG_DDEWAIT = &H100
Private Const SEE_MASK_DOENVSUBST = &H200
Private Const SEE_MASK_FLAG_NO_UI = &H400

' ShellExecuteEx parameters
Private Type SHELLEXECUTEINFO
   cbSize As Long
   fMask As Long
   hWnd As Long
   lpVerb As String
   lpFile As String
   lpParameters As String
   lpDirectory As String
   nShow As Long
   hInstApp As Long
   '  Optional fields
   lpIDList As Long
   lpClass As String
   hkeyClass As Long
   dwHotKey As Long
   hIcon As Long
   hProcess As Long
End Type

Public Function ShowFilePropertiesDialog(ByVal FileSpec As String, ByVal hWndMsgOwner As Long) As Boolean
   Dim sei As SHELLEXECUTEINFO
    
   With sei
      .cbSize = Len(sei)
      .fMask = SEE_MASK_INVOKEIDLIST _
               Or SEE_MASK_FLAG_NO_UI _
               Or SEE_MASK_DOENVSUBST
      .hWnd = hWndMsgOwner
      .lpVerb = "properties"
      .lpFile = FileSpec
   End With
   Call ShellExecuteEx(sei)
    
   ' An "instance handle" is always greater than 32
   ' An error value from this call is always less than 32
   ShowFilePropertiesDialog = (sei.hInstApp > 32)
End Function


